javax.lang.model.type

## Interface TypeMirror

All Known Subinterfaces:
  ArrayType, DeclaredType, ErrorType, ExecutableType, NoType, NullType, PrimitiveType, ReferenceType, TypeVariable, WildcardType

    public interface TypeMirror

Represents a type in the Java programming language. Types include primitive types, declared types (class and interface types), array types, type variables, and the null type. Also represented are wildcard type arguments, the signature and return types of executables, and pseudo-types corresponding to packages and to the keyword `void`.

Types should be compared using the utility methods in `Types`. There is no guarantee that any particular type will always be represented by the same object.

To implement operations based on the class of an `TypeMirror` object, either use a visitor or use the result of the `getKind()` method. Using `instanceof` is not necessarily a reliable idiom for determining the effective class of an object in this modeling hierarchy since an implementation may choose to have a single object implement multiple `TypeMirror` subinterfaces.

Since:
  1.6
See Also:
  `Element`, `Types`

### Method Summary

Methods
`<R,P> R` `accept(TypeVisitor<R,P> v, P p)` Applies a visitor to this type.
`boolean` `equals(Object obj)` Obeys the general contract of `Object.equals`.
`TypeKind` `getKind()` Returns the `kind` of this type.
`int` `hashCode()` Obeys the general contract of `Object.hashCode`.
`String` `toString()` Returns an informative string representation of this type.

### Method Detail

#### getKind

    TypeKind getKind()

Returns the `kind` of this type.

Returns:
  the kind of this type

#### equals

    boolean equals(Object obj)

Obeys the general contract of `Object.equals`. This method does not, however, indicate whether two types represent the same type. Semantic comparisons of type equality should instead use `Types.isSameType(TypeMirror, TypeMirror)`. The results of `t1.equals(t2)` and `Types.isSameType(t1, t2)` may differ.

Overrides:
  `equals` in class `Object`
Parameters:
  `obj` - the object to be compared with this type
Returns:
  `true` if the specified object is equal to this one
See Also:
  `Object.hashCode()`, `Hashtable`

#### hashCode

    int hashCode()

Obeys the general contract of `Object.hashCode`.

Overrides:
  `hashCode` in class `Object`
Returns:
  a hash code value for this object.
See Also:
  `equals(java.lang.Object)`

#### toString

    String toString()

Returns an informative string representation of this type. If possible, the string should be of a form suitable for representing this type in source code. Any names embedded in the result are qualified if possible.

Overrides:
  `toString` in class `Object`
Returns:
  a string representation of this type

#### accept

    <R,P> R accept(TypeVisitor<R,P> v,
                 P p)

Applies a visitor to this type.

Type Parameters:
  `R` - the return type of the visitor's methods
  `P` - the type of the additional parameter to the visitor's methods
Parameters:
  `v` - the visitor operating on this type
  `p` - additional parameter to the visitor
Returns:
  a visitor-specified result

Copyright © 1993, 2017, Oracle and/or its affiliates. All rights reserved.